package com.ekexiu.console.servlet;

import java.io.IOException;
import java.io.OutputStream;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.jfw.util.ConstData;
import org.jfw.util.auth.AuthUtil;
import org.jfw.util.context.JfwAppContext;

import com.ekexiu.console.system.po.SysRight;
import com.ekexiu.console.system.service.RightService;
import com.ekexiu.console.system.vo.ConsoleAuthUser;

public class AuthCssServlet extends HttpServlet {

	private static final long serialVersionUID = -2443799398873114107L;

	private static final int[] EMPTY_RIGHT = new int[] {};

	private RightService rightService;

	@Override
	protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
		StringBuilder sb = new StringBuilder();
		int[] rights = EMPTY_RIGHT;
		ConsoleAuthUser cau = (ConsoleAuthUser) req.getSession().getAttribute(org.jfw.util.auth.AuthUser.LOGIN_USER_FLAG_IN_SESSION);
		if (cau != null) {
			rights = AuthUtil.unCompress(cau.getAuths());
		}
		sb.append("@charset \"UTF-8\";").append("\n");
		for (SysRight r : this.rightService.query()) {
			boolean found = false;
			for (int rc : rights) {
				if (rc == r.getId()) {
					found = true;
					break;
				}
			}
			if (!found) {
				sb.append(".auth-").append(r.getId()).append(",");
			}
		}

		sb.append("auth-FFFFFFF{display:none;}");

		byte[] bs = sb.toString().getBytes(ConstData.UTF8);
		resp.setDateHeader("Expires", 0);
		resp.setHeader("Cache-Control", "no-store, no-cache, must-revalidate");
		resp.addHeader("Cache-Control", "post-check=0, pre-check=0");
		resp.setHeader("Pragma", "no-cache");
		resp.setContentType("text/css");
		resp.setContentLength(bs.length);
		OutputStream os = resp.getOutputStream();
		try {
			os.write(bs);
			os.flush();
		} finally {
			os.close();
		}
	}

	@Override
	public void init() throws ServletException {
		super.init();
		this.rightService = JfwAppContext.getBeanFactory().getBean("com_ekexiu_console_system_service_RightService", RightService.class);
	}

}
