package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.AuthApply;
import com.ekexiu.console.system.pojo.AuthApplyInfo;
import com.ekexiu.console.system.pojo.OrgApplyInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/3/30.
 */
@DAO
public abstract class AuthApplyDao {

    @Insert
    public abstract int insert(Connection con, AuthApply authApply) throws SQLException;

    @Update
    public abstract int update(Connection con, AuthApply authApply) throws SQLException;

    @UpdateWith
    @From(AuthApply.class)
    public abstract int updateSolveStatus(Connection con, @Set Integer solveStatus, String authApplyId) throws SQLException;

    @Nullable
    @SelectOne
    public abstract AuthApply queryOne(Connection con, String authApplyId) throws SQLException;

    public AuthApply queryPro(Connection con, String professorId) throws SQLException {
        int _m_1 = 1;
        String sql = "SELECT AUTH_APPLY_ID,PROFESSOR_ID,APPLY_TYPE,SOLVE_STATUS FROM AUTH_APPLY "
                + " WHERE PROFESSOR_ID = ? ORDER BY CREATE_TIME DESC LIMIT 1";
        PreparedStatement ps = con.prepareStatement(sql);
        try {
            ps.setString(_m_1++, professorId);
            ResultSet rs = ps.executeQuery();
            try {
                if (rs.next()) {
                    AuthApply _result = new AuthApply();
                    _result.setAuthApplyId(rs.getString(1));
                    _result.setProfessorId(rs.getString(2));
                    _result.setApplyType(rs.getInt(3));
                    _result.setSolveStatus(rs.getInt(4));
                    return _result;
                } else {
                    return null;
                }
            } finally {
                try {
                    rs.close();
                } catch (Exception e1) {
                }
            }
        } finally {
            try {
                ps.close();
            } catch (Exception e2) {
            }
        }
    }

    @QueryList
    @OrderBy("ORDER BY CREATE_TIME")
    public abstract List<AuthApplyInfo> queryInfo(Connection con, Integer applyType) throws SQLException;

    @QueryOne
    @Nullable
    public abstract AuthApplyInfo queryInfo(Connection con, String authApplyId) throws SQLException;

    @QueryList
    @OrderBy("ORDER BY CREATE_TIME")
    public abstract List<OrgApplyInfo> queryOrgInfo(Connection con, Integer applyType)throws SQLException;

    @QueryOne
    @Nullable
    public abstract OrgApplyInfo queryOrgInfo(Connection con, String authApplyId) throws SQLException;

    @PageSelect
    @OrderBy("ORDER BY PROFESSOR_ID")
    public abstract PageQueryResult<AuthApply> query(Connection con, @Nullable @Like String professorId, @Nullable Integer solveStatus, @GtEq @Nullable @Alias("createTime") String bt,
                                                         @LtEq @Nullable @Alias("createTime") String et, int pageSize, int pageNo) throws SQLException;

}
