package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.pojo.ConsultInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryList;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/5/3.
 */
@DAO
public interface ConsultDao {

    @QueryList
    @OrderBy("ORDER BY CREATE_TIME DESC")
    List<ConsultInfo> query(Connection con) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY create_time DESC")
    PageQueryResult<ConsultInfo> pageQuery(Connection con, @Nullable @Like String consultantName, @Nullable @Like String professorName,@Nullable @Like String consultTitle,@Nullable Integer consultStatus, int pageSize, int pageNo) throws SQLException;

    @Nullable
    @QueryOne
    ConsultInfo query(Connection con, String consultId) throws SQLException;

    @Nullable
    @QueryList
    @OrderBy("ORDER BY create_time ASC")
    List<ConsultInfo> queryDemand(Connection con, String demandId) throws SQLException;
}
