package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.CustPower;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import java.sql.Connection;
import java.sql.SQLException;

@DAO
public interface CustPowerDao {
	@Insert
	int insert(Connection con, CustPower custPower) throws SQLException;
	@UpdateWith
	@From(CustPower.class)
    int update(Connection con, @Set String powType, String powerId) throws SQLException;
	@DeleteWith
	@From(CustPower.class)
	int delete(Connection con, String powerId) throws SQLException;

	@DeleteWith
	@Batch
	@From(CustPower.class)
	int[] delete(Connection con, @Batch String[] powerId) throws SQLException;
}
