package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.CustomerRecord;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@DAO
public interface CustomerRecordDao {
	@Insert
	int insert(Connection con, CustomerRecord customerRecord) throws SQLException;
	@Update
	int update(Connection con, CustomerRecord customerRecord) throws SQLException;

	@DeleteWith
	@From(CustomerRecord.class)
	int delete(Connection con, String recordId) throws SQLException;

	@DeleteWith
	@Batch
	@From(CustomerRecord.class)
	int[] delete(Connection con, @Batch String[] recordId) throws SQLException;
	
	@Nullable
	@SelectOne
	CustomerRecord query(Connection con, String recordId) throws SQLException;
	
	@OrderBy("ORDER BY create_time ASC")
	@SelectList
	List<CustomerRecord> queryList(Connection con, String professorId)throws SQLException;	

}