package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Demand;
import com.ekexiu.console.system.pojo.DemandInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.PageQuery;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/5/8.
 */
@DAO
public interface DemandDao {

    @Nullable
    @QueryOne
    DemandInfo query(Connection con, String demandId) throws SQLException;

    @PageQuery
    @OrderBy("ORDER BY CREATE_TIME DESC")
    PageQueryResult<DemandInfo> pageQuery(Connection con, @Nullable @Like String demandTitle, @Nullable @Like String professorName,
                                          @Nullable @Like String demandAim, @Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageNo, int pageSize)throws SQLException;

    @UpdateWith
    @From(Demand.class)
    int updateDemandStatus(Connection con,String demandId,@Set String demandStatus,@Set String closeTime)throws SQLException;
}
