package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import com.ekexiu.console.system.po.Dict;

@DAO
public interface DictDao {

	@SelectList
	List<Dict> queryAlll(Connection con)throws SQLException;
	@Update
	int update(Connection con ,Dict dict)throws SQLException;
	
	@Insert
	int insert(Connection con,Dict dict)throws SQLException;
	
	@Nullable
	@QueryVal
	@Column(value="ITEM",handlerClass=StringHandler.class)
	@From(Dict.class)
	String queryItem(Connection con,String code)throws SQLException;
	
	@UpdateWith
	@From(Dict.class)
	int update(Connection con,String code,@Set String item)throws SQLException;
	
	@DeleteWith
	@From(Dict.class)
	int delete(Connection con,String code)throws SQLException;
}
