package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Honor;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/7/14.
 */
@DAO
public interface HonorDao {
    @Insert
    int insert(Connection con, Honor honor) throws SQLException;

    @Update
    int update(Connection con, Honor honor) throws SQLException;

    @SelectList
    @OrderBy(" ORDER BY YEAR DESC ")
    List<Honor> query(Connection con, String professorId) throws SQLException;

    @Nullable
    @SelectOne
    Honor queryOne(Connection con, String id) throws SQLException;

    @DeleteWith
    @From(Honor.class)
    int delete(Connection con, String id) throws SQLException;
}
