package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Luser;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.Or;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.QueryVal;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/7/13.
 */
@DAO
public interface LuserDao {

    @Or
    @Nullable
    @SelectOne
    Luser check(Connection con, @Alias({ "mobilePhone", "email" }) String key) throws SQLException;

    @Insert
    int insert(Connection con,Luser user)throws SQLException;

    @Nullable
    @QueryVal
    @Column(handlerClass=StringHandler.class,value="id")
    @From(Luser.class)
    String queryByEmail(Connection con,String email)throws SQLException;

    @Nullable
    @QueryVal
    @Column(handlerClass=StringHandler.class,value="id")
    @From(Luser.class)
    String queryByPhone(Connection con,String mobilePhone)throws SQLException;

    @UpdateWith
    @From(Luser.class)
    int updateAccount(Connection con, String id, @Set String mobilePhone, @Set String email)throws SQLException;

    @SelectOne
    @Nullable
    Luser query(Connection con, String id) throws SQLException;
}
