package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Organization;
import com.ekexiu.console.system.pojo.OrganizationInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

@DAO
public interface OrgDao {
	@Insert
	int insert(Connection con, Organization org) throws SQLException;

	@Update
	int update(Connection con, Organization org) throws SQLException;

	@DeleteWith
	@From(Organization.class)
	int delete(Connection con, String id) throws SQLException;

	@DeleteWith
	@Batch
	@From(Organization.class)
	int[] delete(Connection con, @Batch String[] id) throws SQLException;

	@Nullable
	@QueryOne
	OrganizationInfo query(Connection con, String id) throws SQLException;

	@UpdateWith
	@From(Organization.class)
	int updateOrgName(Connection con,String id,@Set String name)throws SQLException;

	@UpdateWith
	@From(Organization.class)
	int updateAuthStatus(Connection con,String id,@Set String authStatus)throws SQLException;

	@UpdateWith
	@From(Organization.class)
	int updateIsJoin(Connection con,String id,@Set String isJoin)throws SQLException;

	@PageQuery
	@OrderBy(" ORDER BY ou.create_time DESC NULLS LAST")
	PageQueryResult<OrganizationInfo> queryTime(Connection con, @Nullable @Like String name, @Nullable @Like String industry, @Nullable @Like String subject, @Nullable @Like String city, @Nullable String authStatus, @Nullable @GtEq @Alias("accountTime") String bt, @Nullable @Alias("accountTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

	@PageQuery
	@OrderBy(" ORDER BY page_views DESC NULLS LAST")
	PageQueryResult<OrganizationInfo> queryViews(Connection con, @Nullable @Like String name, @Nullable @Like String industry, @Nullable @Like String subject, @Nullable @Like String city, @Nullable String authStatus, @Nullable @GtEq @Alias("accountTime") String bt, @Nullable @Alias("accountTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

	@Nullable
	@QueryVal
	@Column(handlerClass=StringHandler.class,value="id")
	@From(Organization.class)
	String queryByName(Connection con,String name)throws SQLException;

	@Nullable
	@SelectOne
	Organization entryCheck(Connection con, @Nullable String name) throws SQLException;

	@UpdateWith
	@From(Organization.class)
	int updateBusinessData(Connection con,String id,@Set String authStatus,@Set Long sortNum)throws SQLException;

	@Nullable
	@QueryVal
	@Column(handlerClass = StringHandler.class, value = "name")
	@From(Organization.class)
	String queryById(Connection con, String id) throws SQLException;
}
