package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.OrgUser;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/5/18.
 */
@DAO
public interface OrgUserDao {

    @Insert
    int insert(Connection con, OrgUser orgUser) throws SQLException;

    @Nullable
    @QueryOne
    OrgUser query(Connection con, String id) throws SQLException;

    @Nullable
    @QueryVal
    @Column(handlerClass=StringHandler.class,value="id")
    @From(OrgUser.class)
    String queryByEmail(Connection con,String email)throws SQLException;

    @Update
    int update(Connection con, OrgUser org) throws SQLException;

    @UpdateWith
    @From(OrgUser.class)
    int updateEmail(Connection con,String id,@Set String email)throws SQLException;

    @Nullable
    @SelectOne
    OrgUser entryCheck(Connection con, @Nullable String email) throws SQLException;
}
