package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.PartTimeJob;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/7/14.
 */
@DAO
public interface PartTimeJobDao {
    @Insert
    int insert(Connection con, PartTimeJob job) throws SQLException;

    @Update
    int update(Connection con, PartTimeJob job) throws SQLException;

    @SelectList
    @OrderBy(" ORDER BY STOP_MONTH DESC ")
    List<PartTimeJob> query(Connection con, String professorId) throws SQLException;

    @Nullable
    @SelectOne
    PartTimeJob queryOne(Connection con, String id) throws SQLException;

    @DeleteWith
    @From(PartTimeJob.class)
    int delete(Connection con, String id) throws SQLException;
}
