package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Professor;
import com.ekexiu.console.system.pojo.ProfessorInfo;
import com.ekexiu.console.system.pojo.UserDetail;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.IncludeFixSet;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.*;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/4/6.
 */
@DAO
public interface ProfessorDao {
    @Insert
    int insert(Connection con, Professor professor) throws SQLException;

    @Update
    int update(Connection con, Professor professor) throws SQLException;

    @UpdateWith
    @From(Professor.class)
    int updateAuthStatus(Connection con, String id, @Set Integer authStatus, @Set String idCard) throws SQLException;

    @UpdateWith
    @From(Professor.class)
    int updateAuthStatusExpert(Connection con, String id, @Set Integer authStatusExpert) throws SQLException;

    @UpdateWith
    @From(Professor.class)
    int updateAuthType(Connection con, String id, @Set Integer authType) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY create_time DESC")
    PageQueryResult<ProfessorInfo> pageQuery(Connection con,@Nullable String enter,@Nullable @Like String orgName, @Nullable @Like String name, @Nullable Integer professorState,
                                             @Nullable @Alias("createTime") @GtEq String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY professor_state desc,create_time desc")
    PageQueryResult<ProfessorInfo> pageQueryPerson(Connection con,String cuserId,@Nullable @Like String orgName, @Nullable @Like String name, @Nullable Integer professorState,
                                             @Nullable @Alias("createTime") @GtEq String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @Batch
    @IncludeFixSet("modifyTime")
    @UpdateWith
    @From(Professor.class)
    int[] updateProfessorState(Connection con, @Batch String[] id, @Set Integer professorState) throws SQLException;

    @Nullable
    @QueryOne
    ProfessorInfo query(Connection con, String id) throws SQLException;

    @UpdateWith
    @From(Professor.class)
    int updateSortFirst(Connection con, String id, @Set Integer sortFirst) throws SQLException;

    @Batch
    @UpdateWith
    @From(Professor.class)
    int[] updateAuthType(Connection con, @Batch String[] id, @Set Integer authType) throws SQLException;

    @Batch
    @UpdateWith
    @From(Professor.class)
    int[] updateAuthStatusExpert(Connection con, @Batch String[] id, @Set Integer authStatusExpert) throws SQLException;

    @Nullable
    @QueryVal
    @Column(handlerClass = StringHandler.class, value = "name")
    @From(Professor.class)
    String queryById(Connection con, String id) throws SQLException;

    @PageQuery
    @OrderBy("ORDER BY create_time DESC NULLS LAST")
    PageQueryResult<UserDetail> pageQueryUserDetail(Connection con, @Nullable @Like String name,@Nullable String activeStatus,@Nullable Integer sendMailStatus,@Nullable @Alias("createTime") @GtEq String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @UpdateWith
    @From(Professor.class)
    int updateBusinessData(Connection con,String id,@Set int authentication,@Set int authStatus,@Set int authStatusExpert ,@Set int sortFirst)throws SQLException;

    @Nullable
    @QueryOne
    UserDetail queryDetail(Connection con, String id)throws SQLException;
}
