package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.Project;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.*;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/7/13.
 */
@DAO
public interface ProjectDao {
    @Insert
    int insert(Connection con, Project project) throws SQLException;

    @Update
    int update(Connection con, Project project) throws SQLException;

    @SelectList
    @OrderBy(" ORDER BY STOP_MONTH DESC ")
    List<Project> query(Connection con, String professorId) throws SQLException;

    @Nullable
    @SelectOne
    Project queryOne(Connection con, String id) throws SQLException;

    @DeleteWith
    @From(Project.class)
    int delete(Connection con, String id) throws SQLException;
}
