package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.ResearchArea;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.UpdateWith;
import org.jfw.apt.orm.annotation.dao.param.Set;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/7/13.
 */
@DAO
public interface ResearchAreaDao {
    @Insert
    int insert(Connection con, ResearchArea area) throws SQLException;

    @OrderBy("ORDER BY COUNT DESC,SORT_NUM ASC")
    @SelectList
    List<ResearchArea> query(Connection con, String professorId) throws SQLException;

    @DeleteWith
    @From(ResearchArea.class)
    int delete(Connection con, String professorId) throws SQLException;

    @DeleteWith
    @From(ResearchArea.class)
    int delete(Connection con, String professorId, String caption) throws SQLException;

    @UpdateWith
    @From(ResearchArea.class)
    int updateDescp(Connection con, String professorId, String caption, @Set String descp, @Set int sortNum) throws SQLException;
}
