package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.ResourceTmp;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Created by TT on 2017/6/5.
 */
@DAO
public abstract class ResourceTmpDao {
    @Insert
    public abstract int insert(Connection con, ResourceTmp rt) throws SQLException;

    public PageQueryResult<ResourceTmp> query(Connection con, String orgName, String key, int pageSize, int pageNo) throws SQLException{
        int total = 0;
        int index = 1;
        PageQueryResult<ResourceTmp> queryResult = new PageQueryResult<ResourceTmp>();
        boolean hasKey = null != key;
        StringBuilder sql = new StringBuilder();
        sql.append(" WHERE ORG_NAME = ?");
        if(hasKey){
            sql.append(" AND (NAME LIKE ? OR DOMAIN LIKE ? OR MAJOR_FUNC LIKE ?)");
        }
        StringBuilder whereSql = sql;
        sql = new StringBuilder();
        sql.append("SELECT COUNT(1) FROM RESOURCE_TMP");
        sql.append(whereSql);
        PreparedStatement ps = con.prepareStatement(sql.toString());
        try{
            ps.setString(index++, orgName);
            if(hasKey){
                ps.setString(index++, key);
                ps.setString(index++, key);
                ps.setString(index++, key);
            }
            queryResult.setPageSize(pageSize);
            ResultSet rs = ps.executeQuery();
            try{
                rs.next();
                total = rs.getInt(1);
            }finally{
                try{rs.close();}catch(Exception e1){}
            }
        }finally{
            try{ps.close();}catch(Exception e2){}
        }
        queryResult.setTotal(total);
        if(0 == total){
            queryResult.setPageNo(1);
            queryResult.setData(Collections.<ResourceTmp>emptyList());
            return queryResult;
        }
        index = 1;
        boolean firstPage = (1 == pageNo);
        sql = new StringBuilder();
        if(firstPage){
            queryResult.setPageNo(1);
            sql.append("SELECT ID,NAME,DOMAIN,COMP,SPEC,IMG,PARAMETER,MAJOR_FUNC,COST,ENABLED_TIME,COMMUNICATION,ORG_NAME,CORPORATION,LINKMAN,TEL,EMAIL,ADDR,ZIP_CODE,CREATE_TIME,MODIFY_TIME FROM RESOURCE_TMP");
            sql.append(whereSql);
            sql.append(" ORDER BY ID");
            sql.append(" LIMIT ").append(pageSize);
        }else{
            int pageNum = total / pageSize;
            if(total % pageSize != 0){
                ++pageNum;
            }
            if(pageNo > pageNum){
                pageNo = pageNum;
            }
            queryResult.setPageNo(pageNo);
            --pageNo;
            int offset = (pageNo * pageSize);
            sql.append("SELECT ID,NAME,DOMAIN,COMP,SPEC,IMG,PARAMETER,MAJOR_FUNC,COST,ENABLED_TIME,COMMUNICATION,ORG_NAME,CORPORATION,LINKMAN,TEL,EMAIL,ADDR,ZIP_CODE,CREATE_TIME,MODIFY_TIME FROM RESOURCE_TMP");
            sql.append(whereSql);
            sql.append(" ORDER BY ID");
            sql.append(" LIMIT ").append(pageSize).append(" OFFSET ").append(offset);
        }
        ps = con.prepareStatement(sql.toString());
        try{
            ps.setString(index++, orgName);
            if(hasKey){
                ps.setString(index++, key);
                ps.setString(index++, key);
                ps.setString(index++, key);
            }
            ResultSet rs = ps.executeQuery();
            try{
                List<ResourceTmp> resourceTmps = new ArrayList<ResourceTmp>();
                queryResult.setData(resourceTmps);
                int size = 0;
                while((size<pageSize) && rs.next()){
                    ++size;
                    ResourceTmp resourceTmp =  new ResourceTmp();
                    resourceTmp.setId(rs.getString(1));
                    resourceTmp.setName(rs.getString(2));
                    String domain = rs.getString(3);
                    if(rs.wasNull()){
                        domain = null;
                    }
                    resourceTmp.setDomain(domain);
                    String comp = rs.getString(4);
                    if(rs.wasNull()){
                        comp = null;
                    }
                    resourceTmp.setComp(comp);
                    String spec = rs.getString(5);
                    if(rs.wasNull()){
                        spec = null;
                    }
                    resourceTmp.setSpec(spec);
                    String img = rs.getString(6);
                    if(rs.wasNull()){
                        img = null;
                    }
                    resourceTmp.setImg(img);
                    String parameter = rs.getString(7);
                    if(rs.wasNull()){
                        parameter = null;
                    }
                    resourceTmp.setParameter(parameter);
                    String majorFunc = rs.getString(8);
                    if(rs.wasNull()){
                        majorFunc = null;
                    }
                    resourceTmp.setMajorFunc(majorFunc);
                    Double cost = rs.getDouble(9);
                    if(rs.wasNull()){
                        cost = null;
                    }
                    resourceTmp.setCost(cost);
                    String enabledTime = rs.getString(10);
                    if(rs.wasNull()){
                        enabledTime = null;
                    }
                    resourceTmp.setEnabledTime(enabledTime);
                    String communication = rs.getString(11);
                    if(rs.wasNull()){
                        communication = null;
                    }
                    resourceTmp.setCommunication(communication);
                    String orgname = rs.getString(12);
                    if(rs.wasNull()){
                        orgname = null;
                    }
                    resourceTmp.setOrgName(orgname);
                    String corporation = rs.getString(13);
                    if(rs.wasNull()){
                        corporation = null;
                    }
                    resourceTmp.setCorporation(corporation);
                    String linkman = rs.getString(14);
                    if(rs.wasNull()){
                        linkman = null;
                    }
                    resourceTmp.setLinkman(linkman);
                    String tel = rs.getString(15);
                    if(rs.wasNull()){
                        tel = null;
                    }
                    resourceTmp.setTel(tel);
                    String email = rs.getString(16);
                    if(rs.wasNull()){
                        email = null;
                    }
                    resourceTmp.setEmail(email);
                    String addr = rs.getString(17);
                    if(rs.wasNull()){
                        addr = null;
                    }
                    resourceTmp.setAddr(addr);
                    String zipCode = rs.getString(18);
                    if(rs.wasNull()){
                        zipCode = null;
                    }
                    resourceTmp.setZipCode(zipCode);
                    resourceTmp.setCreateTime(rs.getString(19));
                    resourceTmp.setModifyTime(rs.getString(20));
                    resourceTmps.add(resourceTmp);
                }
                return queryResult;
            }finally{
                try{rs.close();}catch(Exception e3){}
            }
        }finally{
            try{ps.close();}catch(Exception e4){}
        }
    }

}
