package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;

import com.ekexiu.console.system.po.SysRight;

@DAO
public interface RightDao {

	@Insert
	int insert(Connection con, SysRight right) throws SQLException;

	@Nullable
	@SelectOne
	SysRight query(Connection con, int id) throws SQLException;

	@SelectList
	List<SysRight> query(Connection con) throws SQLException;

	@SelectList
	List<SysRight> query(Connection con, String type) throws SQLException;

	@Update
	int update(Connection con, SysRight right) throws SQLException;

	@DeleteWith
	@From(SysRight.class)
	int delete(Connection con, int id) throws SQLException;

	@Batch
	@DeleteWith
	@From(SysRight.class)
	int[] delete(Connection con, @Batch int[] id) throws SQLException;

}
