package com.ekexiu.console.system.dao;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.DeleteWith;
import org.jfw.apt.orm.annotation.dao.method.operator.Insert;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectList;
import org.jfw.apt.orm.annotation.dao.method.operator.SelectOne;
import org.jfw.apt.orm.annotation.dao.method.operator.Update;
import org.jfw.apt.orm.annotation.dao.param.SqlColumn;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;

import com.ekexiu.console.system.po.Role;

@DAO
public interface RoleDao {

	@Insert
	int insert(Connection con,Role role)throws SQLException;
	
	@Update 
	int update(Connection con,Role role)throws SQLException;
	
	@DeleteWith
	@From(Role.class)
	int delete(Connection con,String id)throws SQLException;
	
	
	@Nullable
	@SelectOne
	Role query(Connection con, String id)throws SQLException;
	@SelectList
	List<Role> query(Connection con)throws SQLException;

	@SelectList
	List<Role> queryByUser(Connection con , @SqlColumn(handlerClass=StringHandler.class,value="id in (SELECT ROLEID FROM USER_ROLE WHERE USERID=?)")  String userid) throws SQLException;
	
}
