package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.UserInfo;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Column;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.Or;
import org.jfw.apt.orm.annotation.dao.method.OrderBy;
import org.jfw.apt.orm.annotation.dao.method.Where;
import org.jfw.apt.orm.annotation.dao.method.operator.*;
import org.jfw.apt.orm.annotation.dao.param.Alias;
import org.jfw.apt.orm.annotation.dao.param.GtEq;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.orm.annotation.dao.param.LtEq;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/7/7.
 */
@DAO
public interface UserInfoDao {

    @Insert
    int insert(Connection con, UserInfo ui) throws SQLException;

    @Update
    int update(Connection con, UserInfo ui) throws SQLException;

    @DeleteWith
    @From(UserInfo.class)
    int delete(Connection con, String id) throws SQLException;

    @SelectOne
    @Nullable
    UserInfo query(Connection con, String id) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY create_time DESC")
    PageQueryResult<UserInfo> queryPerson(Connection con, String creator, @Nullable @Like String name, @Nullable @Like String orgName, @Nullable String state, @Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @PageQuery
    @OrderBy(" ORDER BY create_time DESC")
    @Where("state<>'1'")
    PageQueryResult<UserInfo> queryAll(Connection con, @Nullable @Like String creatorName,@Nullable @Like String name, @Nullable @Like String orgName, @Nullable String state, @Nullable @GtEq @Alias("createTime") String bt, @Nullable @Alias("createTime") @LtEq String et, int pageSize, int pageNo) throws SQLException;

    @Or
    @Nullable
    @SelectOne
    UserInfo entryCheck(Connection con, @Alias({ "mobile", "email" }) String key) throws SQLException;

    @Nullable
    @QueryVal
    @Column(handlerClass=StringHandler.class,value="id")
    @From(UserInfo.class)
    String queryByKey(Connection con,@Alias({ "mobile", "email" }) String key)throws SQLException;

}
