package com.ekexiu.console.system.dao;

import com.ekexiu.console.system.po.UserRole;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.Batch;
import org.jfw.apt.orm.annotation.dao.DAO;
import org.jfw.apt.orm.annotation.dao.method.From;
import org.jfw.apt.orm.annotation.dao.method.operator.*;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@DAO
public interface UserRoleDao {

	@Batch
	@Insert
	int[] insert(Connection con,UserRole[] urs)throws SQLException;
	
	@Batch
	@Delete
	int[] delete(Connection con,UserRole[] urs)throws SQLException;
	
	@DeleteWith
	@From(UserRole.class)
	int deleteByUserId(Connection con,String userid)throws SQLException;
	@DeleteWith
	@From(UserRole.class)
	int deleteByRoleId(Connection con,String roleid)throws SQLException;
	
	@SelectList
	List<UserRole> queryByUserId(Connection con, String userid) throws SQLException;

	@Nullable
	@SelectOne
	UserRole queryByRoleId(Connection con, String roleid) throws SQLException;
	
}
