package com.ekexiu.console.system.po;

import com.ekexiu.console.basepo.CreateTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.defaultImpl.WIntHandler;
import org.jfw.apt.orm.core.enums.DE;

import java.math.BigDecimal;

/**
 * Created by TT on 2017/5/3.
 */
@PrimaryKey("consultId")
@Table
public class Consult implements CreateTimeSupported {
    private String consultId;
    private String consultType;
    private String consultTitle;
    private String consultContant;
    private String createTime;
    private String professorId;
    private String consultantId;
    private Integer consultStatus;
    private String finishTime;
    private Integer assessStatus;
    private Integer assessStar;
    private String assessContant;
    private String assessTime;
    private Integer thanksStatus;
    private BigDecimal thanksMoney;
    private String thanksTime;
    private String revoveryTime;
    private Integer readStatus;
    private String demandId;

    @Column(DE.id_32)
    public String getConsultId() {
        return consultId;
    }
    public void setConsultId(String consultId) {
        this.consultId = consultId;
    }

    @Column(DE.string_de)
    public String getConsultType() {
        return consultType;
    }
    public void setConsultType(String consultType) {
        this.consultType = consultType;
    }

    @Column(DE.string_de)
    public String getConsultTitle() {
        return consultTitle;
    }
    public void setConsultTitle(String consultTitle) {
        this.consultTitle = consultTitle;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",nullable=false,insertable=true,renewable=false,queryable=true)
    public String getConsultContant() {
        return consultContant;
    }
    public void setConsultContant(String consultContant) {
        this.consultContant = consultContant;
    }


    public String getCreateTime() {
        return createTime;
    }
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    @Column(DE.id_32)
    public String getProfessorId() {
        return professorId;
    }
    public void setProfessorId(String professorId) {
        this.professorId = professorId;
    }

    @Column(DE.id_32)
    public String getConsultantId() {
        return consultantId;
    }
    public void setConsultantId(String consultantId) {
        this.consultantId = consultantId;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",nullable=true,insertable=true,renewable=true,queryable=true)
    public Integer getConsultStatus() {
        return consultStatus;
    }
    public void setConsultStatus(Integer consultStatus) {
        this.consultStatus = consultStatus;
    }

    @Column(handlerClass = FixLenStringHandler.class, dbType = "CHAR(14)", insertable = false, nullable = true, queryable = true, renewable = true)
    public String getFinishTime() {
        return finishTime;
    }
    public void setFinishTime(String finishTime) {
        this.finishTime = finishTime;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",nullable=true,insertable=true,renewable=true,queryable=true)
    public Integer getAssessStatus() {
        return assessStatus;
    }
    public void setAssessStatus(Integer assessStatus) {
        this.assessStatus = assessStatus;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",nullable=true,insertable=false,renewable=true,queryable=true)
    public Integer getAssessStar() {
        return assessStar;
    }
    public void setAssessStar(Integer assessStar) {
        this.assessStar = assessStar;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",nullable=true,insertable=false,renewable=true,queryable=true)
    public String getAssessContant() {
        return assessContant;
    }
    public void setAssessContant(String assessContant) {
        this.assessContant = assessContant;
    }

    @Column(handlerClass = FixLenStringHandler.class, dbType = "CHAR(14)", insertable = false, nullable = true, queryable = true, renewable = true)
    public String getAssessTime() {
        return assessTime;
    }
    public void setAssessTime(String assessTime) {
        this.assessTime = assessTime;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",nullable=true,insertable=true,renewable=true,queryable=true)
    public Integer getThanksStatus() {
        return thanksStatus;
    }
    public void setThanksStatus(Integer thanksStatus) {
        this.thanksStatus = thanksStatus;
    }

    @Column(DE.BigDecmimal_de)
    public BigDecimal getThanksMoney() {
        return thanksMoney;
    }
    public void setThanksMoney(BigDecimal thanksMoney) {
        this.thanksMoney = thanksMoney;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(14)",insertable=false,nullable=true,queryable=true,renewable=true)
    public String getThanksTime() {
        return thanksTime;
    }
    public void setThanksTime(String thanksTime) {
        this.thanksTime = thanksTime;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(14)",fixSqlValueWithInsert="TO_CHAR(NOW(),'YYYYMMDDHH24MISS')",
            fixSqlValueWithUpdate="TO_CHAR(NOW(),'YYYYMMDDHH24MISS')",insertable=true,nullable=true,queryable=true,renewable=true)
    public String getRevoveryTime() {
        return revoveryTime;
    }
    public void setRevoveryTime(String revoveryTime) {
        this.revoveryTime = revoveryTime;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",nullable=false,insertable=true,renewable=true,queryable=true)
    public Integer getReadStatus() {
        return readStatus;
    }
    public void setReadStatus(Integer readStatus) {
        this.readStatus = readStatus;
    }

    @Column(value= DE.id_32,nullable=true)
    public String getDemandId() {
        return demandId;
    }
    public void setDemandId(String demandId) {
        this.demandId = demandId;
    }

}
