package com.ekexiu.console.system.po;

import com.ekexiu.console.basepo.CreateTimeSupported;
import com.ekexiu.console.basepo.ModifyTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.BigDecimalHandler;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.defaultImpl.WIntHandler;
import org.jfw.apt.orm.core.enums.DE;

import java.math.BigDecimal;
import java.util.List;

/**
 * Created by TT on 2017/4/6.
 */
@PrimaryKey("id")
@Table
public class Professor implements CreateTimeSupported,ModifyTimeSupported {
    private String id;
    private String name;
    private String office;
    /**
     *职称
     */
    private String title;
    private String orgId;
    private String department;
    /**
     * 学科
     */
    private String subject;
    /**
     * 应用行业
     */
    private String industry;
    private String province;
    private String address;
    private String descp;
    private String createTime;
    private String modifyTime;
    private BigDecimal starLevel;
    private Integer consultCount;
    private BigDecimal starAvg;
    private Integer authentication;
    private Integer authType;
    private Integer authStatus;
    private Integer authStatusExpert;
    private String orgAuth;
    private String phone;
    private String email;
    private String idCard;
    private String cuserId;
    private Integer professorState;
    private Integer sortFirst;
    private long pageViews;

    private List<ResearchArea> researchAreas;
    
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",renewable=false)

    public String getOrgAuth() {
        return orgAuth;
    }

    public void setOrgAuth(String orgAuth) {
        this.orgAuth = orgAuth;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getCuserId() {
        return cuserId;
    }

    public void setCuserId(String cuserId) {
        this.cuserId = cuserId;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=false,renewable=true,queryable=true)
    public Integer getProfessorState() {
        return professorState;
    }

    public void setProfessorState(Integer professorState) {
        this.professorState = professorState;
    }

    @Column(value= DE.String_de,dbType="VARCHAR(18)")
    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    @Column(value=DE.String_de,dbType="TEXT")
    public String getOffice() {
        return office;
    }

    public void setOffice(String office) {
        this.office = office;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getSubject() {
        return subject;
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }
    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getIndustry() {
        return industry;
    }

    public void setIndustry(String industry) {
        this.industry = industry;
    }

    /**
     * 所在省份
     * @return
     */
    @Column(DE.String_de)
    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    /**
     * 所在城市
     * @return
     */
    @Column(DE.String_de)
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    /**
     * 机构部门
     * @return
     */
    @Column(DE.String_de)
    public String getDepartment() {
        return department;
    }

    public void setDepartment(String department) {
        this.department = department;
    }

    /**
     * 任职机构ID
     * @return
     */
    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getOrgId() {
        return orgId;
    }

    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }

    /**
     * 职称
     * @return
     */
    @Column(DE.String_de)
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    @Column(DE.id_32)
    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    @Column(DE.dictCaption)
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getDescp() {
        return descp;
    }

    public void setDescp(String descp) {
        this.descp = descp;
    }

    public String getCreateTime() {
        return createTime;
    }

    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }

    @Column(handlerClass=BigDecimalHandler.class,dbType="DECIMAL",insertable=false,nullable=false,renewable=false,queryable=true)
    public BigDecimal getStarLevel() {
        return starLevel;
    }

    public void setStarLevel(BigDecimal starLevel) {
        this.starLevel = starLevel;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=false,nullable=false,renewable=false,queryable=true)
    public Integer getConsultCount() {
        return consultCount;
    }

    public void setConsultCount(Integer consultCount) {
        this.consultCount = consultCount;
    }

    @Column(handlerClass=BigDecimalHandler.class,dbType="DECIMAL",insertable=false,nullable=false,renewable=false,queryable=true)
    public BigDecimal getStarAvg() {
        return starAvg;
    }

    public void setStarAvg(BigDecimal starAvg) {
        this.starAvg = starAvg;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=true,renewable=false,queryable=true)
    public Integer getAuthentication() {
        return authentication;
    }

    public void setAuthentication(Integer authentication) {
        this.authentication = authentication;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=false,renewable=false,queryable=true)
    public Integer getAuthType() {
        return authType;
    }

    public void setAuthType(Integer authType) {
        this.authType = authType;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=false,renewable=false,queryable=true)
    public Integer getAuthStatus() {
        return authStatus;
    }

    public void setAuthStatus(Integer authStatus) {
        this.authStatus = authStatus;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=true,renewable=false,queryable=true)
    public Integer getAuthStatusExpert() {
        return authStatusExpert;
    }

    public void setAuthStatusExpert(Integer authStatusExpert) {
        this.authStatusExpert = authStatusExpert;
    }

    @Column(value= DE.String_de,dbType="VARCHAR(20)")
    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    @Column(DE.Email_de)
    public String getEmail() {
        return email;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    @Column(handlerClass=WIntHandler.class,dbType="INT",insertable=true,nullable=false,renewable=false,queryable=true)
    public Integer getSortFirst() {
        return sortFirst;
    }

    public void setSortFirst(Integer sortFirst) {
        this.sortFirst = sortFirst;
    }

    @Column(DE.bigSerial)
    public long getPageViews() {
        return pageViews;
    }

    public void setPageViews(long pageViews) {
        this.pageViews = pageViews;
    }

    public List<ResearchArea> getResearchAreas() {
        return researchAreas;
    }

    public void setResearchAreas(List<ResearchArea> researchAreas) {
        this.researchAreas = researchAreas;
    }
}

