package com.ekexiu.console.system.po;

import com.ekexiu.console.basepo.CreateTimeSupported;
import com.ekexiu.console.basepo.ModifyTimeSupported;
import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.defaultImpl.FixLenStringHandler;
import org.jfw.apt.orm.core.defaultImpl.IntHandler;
import org.jfw.apt.orm.core.defaultImpl.LongHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

/**
 * Created by TT on 2017/7/26.
 */
@PrimaryKey("resourceId")
@Table
public class Resource implements CreateTimeSupported, ModifyTimeSupported {
    private String resourceId;
    private String resourceName;
    /**
     * 关键字
     */
    private String subject;
    private String industry;
    /**
     * 资源提供的服务、应用用途
     */
    private String supportedServices;
    private String orgName;
    /**
     * 厂商及型号规格
     */
    private String spec;
    /**
     * 性能参数
     */
    private String parameter;
    /**
     *
     */
    private String status;
    private String descp;
    private String professorId;
    /**
     * 资源所属（个人/机构）
     */
    private String ascription;
    private String createTime;
    private String modifyTime;
    private String hopePayMethod;
    /**
     * 合作备注
     */
    private String cooperationNotes;
    /**
     * 发布时间
     */
    private String publishTime;
    /**
     * 浏览量
     */
    private int pageViews;
    /**
     * 所在单位
     */
    private String comp;
    /**
     * 资源类型(1-个人资源，2-企业资源)
     */
    private String resourceType;
    private String orgId;

    private long shareId;
    private long sortNum;

    @Column(DE.id_32)
    public String getResourceId() {
        return resourceId;
    }
    public void setResourceId(String resourceId) {
        this.resourceId = resourceId;
    }

    @Column(DE.dictCaption)
    public String getResourceName() {
        return resourceName;
    }
    public void setResourceName(String resourceName) {
        this.resourceName = resourceName;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getSubject() {
        return subject;
    }
    public void setSubject(String subject) {
        this.subject = subject;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getIndustry() {
        return industry;
    }
    public void setIndustry(String industry) {
        this.industry = industry;
    }

    @Column(DE.string_de)
    public String getSupportedServices() {
        return supportedServices;
    }
    public void setSupportedServices(String supportedServices) {
        this.supportedServices = supportedServices;
    }

    @Column(DE.String_de)
    public String getOrgName() {
        return orgName;
    }
    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    @Column(DE.String_de)
    public String getSpec() {
        return spec;
    }
    public void setSpec(String spec) {
        this.spec = spec;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="TEXT",nullable=true)
    public String getParameter() {
        return parameter;
    }
    public void setParameter(String parameter) {
        this.parameter = parameter;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(1)",nullable=true,renewable=false)
    public String getStatus() {
        return status;
    }
    public void setStatus(String status) {
        this.status = status;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getDescp() {
        return descp;
    }
    public void setDescp(String descp) {
        this.descp = descp;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",nullable=true,renewable=false)
    public String getProfessorId() {
        return professorId;
    }
    public void setProfessorId(String professorId) {
        this.professorId = professorId;
    }

    @Column(DE.String_de)
    public String getAscription() {
        return ascription;
    }
    public void setAscription(String ascription) {
        this.ascription = ascription;
    }

    public String getCreateTime() {
        return createTime;
    }
    public void setCreateTime(String createTime) {
        this.createTime = createTime;
    }

    public String getModifyTime() {
        return modifyTime;
    }
    public void setModifyTime(String modifyTime) {
        this.modifyTime = modifyTime;
    }

    @Column(DE.String_de)
    public String getHopePayMethod() {
        return hopePayMethod;
    }
    public void setHopePayMethod(String hopePayMethod) {
        this.hopePayMethod = hopePayMethod;
    }

    @Column(handlerClass=StringHandler.class,dbType="TEXT",insertable=true,nullable=true,renewable=true,queryable=true)
    public String getCooperationNotes() {
        return cooperationNotes;
    }
    public void setCooperationNotes(String cooperationNotes) {
        this.cooperationNotes = cooperationNotes;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(14)",nullable=true,renewable=false)
    public String getPublishTime() {
        return publishTime;
    }
    public void setPublishTime(String publishTime) {
        this.publishTime = publishTime;
    }

    @Column(handlerClass=IntHandler.class,dbType="INTEGER",nullable=true,renewable=false)
    public int getPageViews() {
        return pageViews;
    }
    public void setPageViews(int pageViews) {
        this.pageViews = pageViews;
    }

    @Column(handlerClass=StringHandler.class,nullable=true,renewable=false)
    public String getComp() {
        return comp;
    }
    public void setComp(String comp) {
        this.comp = comp;
    }

    @Column(handlerClass=FixLenStringHandler.class,nullable=true,renewable=false)
    public String getResourceType() {
        return resourceType;
    }
    public void setResourceType(String resourceType) {
        this.resourceType = resourceType;
    }

    @Column(handlerClass=FixLenStringHandler.class,dbType="CHAR(32)",nullable=true,renewable=false)
    public String getOrgId() {
        return orgId;
    }
    public void setOrgId(String orgId) {
        this.orgId = orgId;
    }
    @Column(DE.bigSerial)
    public long getShareId() {
        return shareId;
    }
    public void setShareId(long shareId) {
        this.shareId = shareId;
    }

    @Column(handlerClass=LongHandler.class,dbType="BIGINT",fixSqlValueWithInsert="0",insertable=true,renewable=false,nullable=false,queryable=true)
    public long getSortNum() {
        return sortNum;
    }

    public void setSortNum(long sortNum) {
        this.sortNum = sortNum;
    }
}
