package com.ekexiu.console.system.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.annotation.entry.Unique;
import org.jfw.apt.orm.annotation.entry.Uniques;
import org.jfw.apt.orm.core.defaultImpl.BooleanHandler;
import org.jfw.apt.orm.core.defaultImpl.StringHandler;
import org.jfw.apt.orm.core.enums.DE;

import com.ekexiu.console.basepo.CreateTimeSupported;
import com.ekexiu.console.basepo.DescpSupported;
import com.ekexiu.console.basepo.ModifyTimeSupported;

@PrimaryKey("id")
@Uniques({ @Unique(name = "UN_CUSER_MOBILE", clolumns = "mobile"), @Unique(name = "UN_CUSER_EMAIL", clolumns = "email") })
@Table("CUSER")
public class User implements CreateTimeSupported, ModifyTimeSupported, DescpSupported {

	private String id;
	private String loginPassword;
	private String mobile;
	private String createTime;
	private String modifyTime;
	private String descp;
	private String name;
	private String email;
	private String head;
	private String authinfo;
	private boolean actived = true;

	@Column(DE.id_32)
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	@Column(DE.md5_de)
	public String getLoginPassword() {
		return loginPassword;
	}

	public void setLoginPassword(String loginPassword) {
		this.loginPassword = loginPassword;
	}

	@Column(dbType = "CHAR(11)", handlerClass = StringHandler.class, nullable = true)
	public String getMobile() {
		return mobile;
	}

	public void setMobile(String mobile) {
		this.mobile = mobile;
	}

	public String getCreateTime() {
		return createTime;
	}

	public void setCreateTime(String createTime) {
		this.createTime = createTime;
	}

	public String getModifyTime() {
		return modifyTime;
	}

	public void setModifyTime(String modifyTime) {
		this.modifyTime = modifyTime;
	}

	public String getDescp() {
		return descp;
	}

	public void setDescp(String descp) {
		this.descp = descp;
	}

	@Column(DE.string_de)
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	@Column(DE.string_de)
	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	@Column(DE.String_de)
	public String getHead() {
		return head;
	}

	public void setHead(String head) {
		this.head = head;
	}

	@Column(dbType = "TEXT", handlerClass = StringHandler.class, renewable = false)
	public String getAuthinfo() {
		return authinfo;
	}

	public void setAuthinfo(String authinfo) {
		this.authinfo = authinfo;
	}

	@Column(dbType="CHAR(1)",handlerClass=BooleanHandler.class,nullable = false, renewable=false)
	public boolean isActived() {
		return actived;
	}

	public void setActived(boolean actived) {
		this.actived = actived;
	}

}
