package com.ekexiu.console.system.po;

import org.jfw.apt.orm.annotation.entry.Column;
import org.jfw.apt.orm.annotation.entry.PrimaryKey;
import org.jfw.apt.orm.annotation.entry.Table;
import org.jfw.apt.orm.core.enums.DE;
import org.jfw.util.json.JsonService;
import org.jfw.util.reflect.TypeReference;

import java.lang.reflect.Type;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

/**
 * Created by TT on 2017/7/7.
 */
@PrimaryKey("id")
@Table
public class UserInfo implements Map<String, Object> {
    public static Type MAP_TYPE = (new TypeReference<Map<String, Object>>() {
    }).getType();


    private transient Map<String, Object> target = new HashMap<String, Object>();


    @Column(DE.id_32)
    public String getId() {
        return (String) this.get("id");
    }

    public void setId(String id) {
        this.put("id", id);
    }

    @Column(DE.id_32)
    public String getCreator() {
        return (String) this.get("creator");
    }

    public void setCreator(String creator) {
        this.put("creator", creator);
    }

    @Column(DE.Text_de)
    public String getCreatorName() {
        return (String) this.get("creatorName");
    }

    public void setCreatorName(String creatorName) {
        this.put("creatorName", creatorName);
    }

    @Column(DE.Text_de)
    public String getMobile() {
        return (String) this.get("mobile");
    }

    public void setMobile(String mobile) {
        this.put("mobile", mobile);
    }

    @Column(DE.Text_de)
    public String getEmail() {
        return (String) this.get("email");
    }

    public void setEmail(String email) {
        this.put("email", email);
    }

    @Column(DE.Text_de)
    public String getOrgName() {
        return (String) this.get("orgName");
    }

    public void setOrgName(String orgName) {
        this.put("orgName", orgName);
    }

    @Column(DE.text_de)
    public String getState() {
        return (String) this.get("state");
    }

    public void setState(String state) {
        this.put("state", state);
    }

    @Column(DE.text_de)
    public String getName() {
        return (String) this.get("name");
    }

    public void setName(String name) {
        this.put("name", name);
    }

    @Column(DE.text_de)
    public String getCreateTime() {
        return (String) this.get("createTime");
    }


    public void setCreateTime(String createTime) {
        this.put("createTime", createTime);
    }

    @Column(DE.text_de)
    public String getCnt() {
        return JsonService.toJson(this);
    }

    public void setCnt(String cnt) {
        Map<String, Object> map = JsonService.fromJson(cnt, MAP_TYPE);
        this.putAll(map);
    }


    public static void main(String[] args) throws Exception {
        UserInfo ui = new UserInfo();
        ui.setId("dddd");
        ui.setState("2");
        String s = JsonService.toJson(ui);
        System.out.println(s);
        ui = JsonService.fromJson(s, UserInfo.class);
        System.out.println(ui.getId());
        System.out.println(ui.getState());

    }

    @Override
    public int size() {
        return target.size();
    }

    @Override
    public boolean isEmpty() {
        return target.isEmpty();
    }

    @Override
    public boolean containsKey(Object key) {
        return target.containsKey(key);
    }

    @Override
    public boolean containsValue(Object value) {
        return target.containsValue(value);
    }

    @Override
    public Object get(Object key) {
        return target.get(key);
    }

    @Override
    public Object put(String key, Object value) {
        return target.put(key, value);
    }

    @Override
    public Object remove(Object key) {
        return target.remove(key);
    }

    @Override
    public void putAll(Map<? extends String, ?> m) {
        target.putAll(m);
    }

    @Override
    public void clear() {
        target.clear();
    }

    @Override
    public Set<String> keySet() {
        return target.keySet();
    }

    @Override
    public Collection<Object> values() {
        return target.values();
    }

    @Override
    public Set<Entry<String, Object>> entrySet() {
        return target.entrySet();
    }
}
