package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.AuthApplyDao;
import com.ekexiu.console.system.dao.OrgDao;
import com.ekexiu.console.system.dao.ProfessorDao;
import com.ekexiu.console.system.po.AuthApply;
import com.ekexiu.console.system.pojo.AuthApplyInfo;
import com.ekexiu.console.system.pojo.OrgApplyInfo;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

/**
 * Created by TT on 2017/3/30.
 */

@Path("/authApply")
public class AuthApplyService {

    @Autowrie
    private AuthApplyDao authApplyDao;
    @Autowrie
    private ProfessorDao professorDao;
    @Autowrie
    private OrgDao orgDao;

    public OrgDao getOrgDao() {
        return orgDao;
    }

    public void setOrgDao(OrgDao orgDao) {
        this.orgDao = orgDao;
    }

    public ProfessorDao getProfessorDao() {
        return professorDao;
    }

    public void setProfessorDao(ProfessorDao professorDao) {
        this.professorDao = professorDao;
    }

    public AuthApplyDao getAuthApplyDao() {
        return authApplyDao;
    }

    public void setAuthApplyDao(AuthApplyDao authApplyDao) {
        this.authApplyDao = authApplyDao;
    }

    @Put
    @Path
    public void update(@JdbcConn(true) Connection con, @RequestBody AuthApply authApply) throws SQLException {
        this.authApplyDao.update(con, authApply);
    }

    @Post
    @Path("/solveStatus")
    public void updateSolveStatus(@JdbcConn(true) Connection con, @Set Integer solveStatus, String authApplyId) throws SQLException {
        this.authApplyDao.updateSolveStatus(con, solveStatus, authApplyId);
    }

    @Post
    @Path("/state")
    public void updateState(@JdbcConn(true) Connection con, String authApplyId, Integer solveStatus, Integer applyType, String professorId,String idCard) throws SQLException {
        this.authApplyDao.updateSolveStatus(con, solveStatus, authApplyId);
        if (applyType == 1) {
            this.professorDao.updateAuthStatus(con, professorId, solveStatus,idCard);
        } else if (applyType == 2) {
            this.professorDao.updateAuthStatusExpert(con, professorId, solveStatus);
            if (solveStatus == 3) {
                this.professorDao.updateAuthType(con, professorId, 1);
            }
        } else if (applyType == 3) {
            this.orgDao.updateAuthStatus(con, professorId, String.valueOf(solveStatus));
        }
    }

    @Get
    @Path("/qaRealName")
    public List<AuthApplyInfo> queryRealName(@JdbcConn Connection con) throws SQLException {
        return this.authApplyDao.queryInfo(con, 1);
    }

    @Get
    @Path("/qaExpert")
    public List<AuthApplyInfo> queryExpert(@JdbcConn Connection con) throws SQLException {
        return this.authApplyDao.queryInfo(con, 2);
    }

    @Get
    @Path("/qaOrg")
    public List<OrgApplyInfo> queryOrg(@JdbcConn Connection con) throws SQLException {
        return this.authApplyDao.queryOrgInfo(con,3);
    }

    @Get
    @Path("/info/{authApplyId}")
    public AuthApplyInfo query(@JdbcConn Connection con, @PathVar String authApplyId) throws SQLException {
        return this.authApplyDao.queryInfo(con, authApplyId);
    }

    @Get
    @Path("/orgInfo/{authApplyId}")
    public OrgApplyInfo queryOrgInfo(@JdbcConn Connection con,@PathVar String authApplyId)throws SQLException {
        return this.authApplyDao.queryOrgInfo(con,authApplyId);
    }


    @Get
    @Path("/pq")
    public PageQueryResult<AuthApply> pageQuery(@JdbcConn Connection con, @Nullable String professorId, @Nullable Integer solveStatus, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize) throws SQLException {
        return this.authApplyDao.query(con, professorId, solveStatus, bt, et, pageSize, pageNo);
    }


}
