package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.*;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/7/27.
 */
@Path("/content")
public class ContentService {

    public static final String ARTICLE="1";
    public static final String PAPER="2";
    public static final String PATENT="3";

    @Autowrie
    private ArticleDao articleDao;
    @Autowrie
    private ResourceDao resourceDao;
    @Autowrie
    private PpatentDao ppatentDao;
    @Autowrie
    private PpaperDao ppaperDao;
    @Autowrie
    private LeaveWordDao leaveWordDao;
    @Autowrie
    private WatchDao watchDao;

    public ArticleDao getArticleDao() {
        return articleDao;
    }

    public void setArticleDao(ArticleDao articleDao) {
        this.articleDao = articleDao;
    }

    public ResourceDao getResourceDao() {
        return resourceDao;
    }

    public void setResourceDao(ResourceDao resourceDao) {
        this.resourceDao = resourceDao;
    }

    public PpatentDao getPpatentDao() {
        return ppatentDao;
    }

    public void setPpatentDao(PpatentDao ppatentDao) {
        this.ppatentDao = ppatentDao;
    }

    public PpaperDao getPpaperDao() {
        return ppaperDao;
    }

    public void setPpaperDao(PpaperDao ppaperDao) {
        this.ppaperDao = ppaperDao;
    }

    public LeaveWordDao getLeaveWordDao() {
        return leaveWordDao;
    }

    public void setLeaveWordDao(LeaveWordDao leaveWordDao) {
        this.leaveWordDao = leaveWordDao;
    }

    public WatchDao getWatchDao() {
        return watchDao;
    }

    public void setWatchDao(WatchDao watchDao) {
        this.watchDao = watchDao;
    }

    @Get
    @Path("/lwCount")
    public int queryCount(@JdbcConn Connection con,String articleId)throws SQLException{
        return this.leaveWordDao.queryCount(con, articleId,ARTICLE);
    }

    @Get
    @Path("/lwCount/paper")
    public int queryCountByPaper(@JdbcConn Connection con,String paperId)throws SQLException{
        return this.leaveWordDao.queryCount(con, paperId,PAPER);
    }

    @Get
    @Path("/lwCount/patent")
    public int queryCountByPatent(@JdbcConn Connection con,String patentId)throws SQLException{
        return this.leaveWordDao.queryCount(con, patentId,PATENT);
    }

    @Get
    @Path("/countProfessor")
    public int countProfessor(@JdbcConn Connection con,String id,short type)throws SQLException{
        return this.watchDao.countProfessor(con, id, type);
    }

    @Path("/pq")
    @Get
    public Object pageQuery(@JdbcConn Connection con, int contentType, @Nullable String title, @Nullable String name, int orderBy, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException{
        if (contentType == 3){
            if (orderBy == 1) {
                return this.articleDao.queryByTime(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
            if (orderBy == 2) {
                return this.articleDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
        }
        if (contentType == 2){
            if (orderBy == 1){
                return this.resourceDao.queryByTime(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
            if (orderBy == 2) {
                return this.resourceDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
        }
        if (contentType == 5){
            if (orderBy == 1){
                return this.ppaperDao.queryByTime(con,title == null ? null : "%" + title + "%",  name == null ? null : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
            if (orderBy == 2) {
                return this.ppaperDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? null : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
        }
        if (contentType == 4){
            if (orderBy == 1){
                return this.ppatentDao.queryByTime(con, title == null ? null : "%" + title + "%",  name == null ? null : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
            if (orderBy == 2) {
                return this.ppatentDao.queryByPV(con, title == null ? null : "%" + title + "%",  name == null ? null : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
            }
        }
        return null;
    }
}
