package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.CustPowerDao;
import com.ekexiu.console.system.po.CustPower;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.orm.annotation.dao.param.Set;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestParam;
import org.jfw.util.StringUtil;

import java.sql.Connection;
import java.sql.SQLException;

@Path("/sys/cpow")
public class CustPowerService {
	@Autowrie
	private CustPowerDao custPowerDao;

	public CustPowerDao getCustPowerDao() {
		return custPowerDao;
	}

	public void setCustPowerDao(CustPowerDao custPowerDao) {
		this.custPowerDao = custPowerDao;
	}
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, @RequestParam(excludeFields = { "createTime", "modifyTime", "powerId" }) CustPower cpower)
			throws SQLException {
		String powerId = StringUtil.buildUUID();
		cpower.setPowerId(powerId);
		this.custPowerDao.insert(con, cpower);
		return powerId;
	}

	@Post
	@Path("/updatacpow")
	public void update(@JdbcConn(true) Connection con, @Set String powType, String powerId) throws SQLException {
	    this.custPowerDao.update(con, powType, powerId);
	}
	@Delete
	@Path("/id/{powerId}")
	public void deleteOne(@JdbcConn(true) Connection con,@PathVar String powerId)throws SQLException{
		this.custPowerDao.delete(con, powerId);
	}
	
	
	@Post
	@Path("/del")
	public void delete(@JdbcConn(true) Connection con,String[] ids)throws SQLException{
		this.custPowerDao.delete(con, ids);
	}	
}
