package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.CustomerRecordDao;
import com.ekexiu.console.system.po.CustomerRecord;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.apt.web.annotation.param.RequestParam;
import org.jfw.util.StringUtil;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.List;

@Path("/sys/crecord")
public class CustomerRecordService {
	@Autowrie
	private CustomerRecordDao customerRecordDao;

	public CustomerRecordDao getCustomerRecordDao() {
		return customerRecordDao;
	}

	public void setCustomerRecordDao(CustomerRecordDao customerRecordDao) {
		this.customerRecordDao = customerRecordDao;
	}
	@Post
	@Path
	public String insert(@JdbcConn(true) Connection con, @RequestParam(excludeFields = { "createTime", "recordId" }) CustomerRecord customerRecord)
			throws SQLException {
		String recordId = StringUtil.buildUUID();
		customerRecord.setRecordId(recordId);
		this.customerRecordDao.insert(con, customerRecord);
		return recordId;
	}

	@Put
	@Path
	public void update(@JdbcConn(true) Connection con,@RequestBody CustomerRecord customerRecord)throws SQLException{
		this.customerRecordDao.update(con, customerRecord);
	}
	@Delete
	@Path("/id/{recordId}")
	public void deleteOne(@JdbcConn(true) Connection con,@PathVar String recordId)throws SQLException{
		this.customerRecordDao.delete(con, recordId);
	}
	
	@Post
	@Path("/del")
	public void delete(@JdbcConn(true) Connection con,String[] ids)throws SQLException{
		this.customerRecordDao.delete(con, ids);
	}
	@Get
	@Path("/id/{id}")
	public CustomerRecord query(@JdbcConn Connection con, @PathVar String id)throws SQLException{
		return this.customerRecordDao.query(con, id);
	}
	@Get
	@Path("/qrecord")
//	public List<CustomerRecord> queryList(@JdbcConn Connection con, @Nullable String professorId,@LoginUser ConsoleAuthUser user) throws SQLException {
//		return this.customerRecordDao.queryList(con, professorId,user.getId());
	public List<CustomerRecord> queryList(@JdbcConn Connection con, @Nullable String professorId) throws SQLException {
		return this.customerRecordDao.queryList(con, professorId);
	}

}