package com.ekexiu.console.system.service;

import com.ekexiu.console.system.mail.MailService;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Post;

import javax.mail.MessagingException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by TT on 2017/5/11.
 */
@Path
public class EmailService {

    @Autowrie
    private MailService mailservice;

    private String phoneContentTemplate;

    private String content = "contentKey";
    private String contentDefault = "";

    private String appellation = "appellationKey";
    private String appellationDefault = "";

    private String phoneReplaceKey = "mobileCode";
    private String inviteReplacePhone = "phoneKey";
    private String inviteReplaceEmail = "mailKey";
    private String inviteReplaceCode = "invitCodeKey";
    private String inviteMailSubject = "[ 科袖网 ]特邀科研专家邀请函";
    private String inviteMailContentTempalte;

    public String getAppellation() {
        return appellation;
    }

    public void setAppellation(String appellation) {
        this.appellation = appellation;
    }

    public String getAppellationDefault() {
        return appellationDefault;
    }

    public void setAppellationDefault(String appellationDefault) {
        this.appellationDefault = appellationDefault;
    }

    public String getContentDefault() {
        return contentDefault;
    }

    public void setContentDefault(String contentDefault) {
        this.contentDefault = contentDefault;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public MailService getMailservice() {
        return mailservice;
    }

    public void setMailservice(MailService mailservice) {
        this.mailservice = mailservice;
    }

    public String getPhoneContentTemplate() {
        return phoneContentTemplate;
    }

    public void setPhoneContentTemplate(String phoneContentTemplate) {
        this.phoneContentTemplate = phoneContentTemplate;
    }

    public String getPhoneReplaceKey() {
        return phoneReplaceKey;
    }

    public void setPhoneReplaceKey(String phoneReplaceKey) {
        this.phoneReplaceKey = phoneReplaceKey;
    }

    public String getInviteReplacePhone() {
        return inviteReplacePhone;
    }

    public void setInviteReplacePhone(String inviteReplacePhone) {
        this.inviteReplacePhone = inviteReplacePhone;
    }

    public String getInviteReplaceEmail() {
        return inviteReplaceEmail;
    }

    public void setInviteReplaceEmail(String inviteReplaceEmail) {
        this.inviteReplaceEmail = inviteReplaceEmail;
    }

    public String getInviteReplaceCode() {
        return inviteReplaceCode;
    }

    public void setInviteReplaceCode(String inviteReplaceCode) {
        this.inviteReplaceCode = inviteReplaceCode;
    }

    public String getInviteMailSubject() {
        return inviteMailSubject;
    }

    public void setInviteMailSubject(String inviteMailSubject) {
        this.inviteMailSubject = inviteMailSubject;
    }

    public String getInviteMailContentTempalte() {
        return inviteMailContentTempalte;
    }

    public void setInviteMailContentTempalte(String inviteMailContentTempalte) {
        this.inviteMailContentTempalte = inviteMailContentTempalte;
    }

    /**
     * 给指定邮箱发送邀请邮件
     *
     * @param mobilePhones 手机号数组
     * @param emails       邮箱
     * @param inviteCodes  邀请码

     * @throws MessagingException
     */
    @Post
    @Path("/sendmail")
    public EmailInfo sendmail(@Nullable String content, @Nullable String appellation, @Nullable String[] mobilePhones, String[] emails, String[] inviteCodes, String[] names)
            throws MessagingException {
        EmailInfo emailInfo = new EmailInfo();
        List<String> email = new ArrayList<>();
        List<String> name = new ArrayList<>();
        int count = 0;
        for (int i = 0; i < emails.length; i++) {
            if (mobilePhones[i] == "") {
                mobilePhones[i] = null;
            }
            if (content == null) {
                content = this.contentDefault;
            }
            if (appellation == null) {
                appellation = this.appellationDefault;
            }
            try {
                this.sendInviteMail(content, appellation, emails[i], mobilePhones[i], inviteCodes[i]);
            } catch (MessagingException e) {
                count++;
                email.add(emails[i]);
                name.add(names[i]);
                continue;
            }
        }
        emailInfo.setCount(emails.length-count);
        emailInfo.setEmails(email);
        emailInfo.setNames(name);
        return emailInfo;
    }

    public void sendInviteMail(String content, String appellation, String email, @Nullable String mobilePhone, String inviteCode)
            throws MessagingException {
        String mailContent = this.inviteMailContentTempalte;
        mailContent = mailContent.replaceAll(this.inviteReplaceEmail, email);
        mailContent = mailContent.replaceAll(this.inviteReplaceCode, inviteCode);
        mailContent = mailContent.replaceAll(this.appellation, appellation);
        mailContent = mailContent.replaceAll(this.content, content);
        String phoneReplace = "";
        if (mobilePhone != null && mobilePhone.trim().length() == 11) {
            String mobile = mobilePhone.trim();
            mobile = mobile.substring(0, 3) + "****" + mobile.substring(7);
            phoneReplace = this.phoneContentTemplate.replaceAll(this.phoneReplaceKey, mobile);
        }
        mailContent = mailContent.replaceAll(this.inviteReplacePhone, phoneReplace);
        this.mailservice.sendSimpleMail(email, mailContent, null, this.inviteMailSubject);
    }

    public static class EmailInfo {

        private int count;
        private List<String> emails;
        private List<String> names;

        public List<String> getNames() {
            return names;
        }

        public void setNames(List<String> names) {
            this.names = names;
        }

        public int getCount() {
            return count;
        }

        public void setCount(int count) {
            this.count = count;
        }

        public List<String> getEmails() {
            return emails;
        }

        public void setEmails(List<String> emails) {
            this.emails = emails;
        }

    }

}
