package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.*;
import com.ekexiu.console.system.po.*;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.Bean;

import java.sql.Connection;
import java.sql.SQLException;
import java.util.Collections;
import java.util.HashSet;

/**
 * Created by TT on 2017/8/10.
 */
@Bean
public class KeyWordService {

    @Autowrie
    private ProKeyWordDao proKeyWordDao;
    @Autowrie
    private OrgKeyWordDao orgKeyWordDao;
    @Autowrie
    private ResKeyWordDao resKeyWordDao;
    @Autowrie
    private ArtKeyWordDao artKeyWordDao;
    @Autowrie
    private PatKeyWordDao patKeyWordDao;
    @Autowrie
    private PapKeyWordDao papKeyWordDao;

    public ProKeyWordDao getProKeyWordDao() {
        return proKeyWordDao;
    }

    public void setProKeyWordDao(ProKeyWordDao proKeyWordDao) {
        this.proKeyWordDao = proKeyWordDao;
    }

    public OrgKeyWordDao getOrgKeyWordDao() {
        return orgKeyWordDao;
    }

    public void setOrgKeyWordDao(OrgKeyWordDao orgKeyWordDao) {
        this.orgKeyWordDao = orgKeyWordDao;
    }

    public ResKeyWordDao getResKeyWordDao() {
        return resKeyWordDao;
    }

    public void setResKeyWordDao(ResKeyWordDao resKeyWordDao) {
        this.resKeyWordDao = resKeyWordDao;
    }

    public ArtKeyWordDao getArtKeyWordDao() {
        return artKeyWordDao;
    }

    public void setArtKeyWordDao(ArtKeyWordDao artKeyWordDao) {
        this.artKeyWordDao = artKeyWordDao;
    }

    public PatKeyWordDao getPatKeyWordDao() {
        return patKeyWordDao;
    }

    public void setPatKeyWordDao(PatKeyWordDao patKeyWordDao) {
        this.patKeyWordDao = patKeyWordDao;
    }

    public PapKeyWordDao getPapKeyWordDao() {
        return papKeyWordDao;
    }

    public void setPapKeyWordDao(PapKeyWordDao papKeyWordDao) {
        this.papKeyWordDao = papKeyWordDao;
    }

    public void refreshProfessor(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        proKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            ProKeyWord[] okws = new ProKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                ProKeyWord okw = new ProKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            proKeyWordDao.insert(con, okws);
        }
    }

    public void refreshOrg(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        orgKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            OrgKeyWord[] okws = new OrgKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                OrgKeyWord okw = new OrgKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            orgKeyWordDao.insert(con, okws);
        }
    }

    public void refreshArticle(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        artKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            ArtKeyWord[] okws = new ArtKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                ArtKeyWord okw = new ArtKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            artKeyWordDao.insert(con, okws);
        }
    }

    public void refreshResource(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        resKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            ResKeyWord[] okws = new ResKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                ResKeyWord okw = new ResKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            resKeyWordDao.insert(con, okws);
        }
    }

    public void refreshPaper(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        papKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            PapKeyWord[] okws = new PapKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                PapKeyWord okw = new PapKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            papKeyWordDao.insert(con, okws);
        }
    }

    public void refreshPatent(Connection con, String id, String kw) throws SQLException {
        String[] kws = splitKeyWord(kw);
        patKeyWordDao.delete(con, id);
        if (kws != null && kws.length > 0) {
            PatKeyWord[] okws = new PatKeyWord[kws.length];
            for (int i = 0; i < kws.length; ++i) {
                PatKeyWord okw = new PatKeyWord();
                okw.setId(id);
                okw.setKw(kws[i]);
                okws[i] = okw;
            }
            patKeyWordDao.insert(con, okws);
        }
    }

    public static String[] splitKeyWord(String kws) {
        if (kws == null || kws.trim().length() == 0) return null;
        kws = kws.trim();
        String[] s = kws.split(",");
        HashSet<String> result = new HashSet<String>();
        Collections.addAll(result, s);
        result.remove("");

        return result.isEmpty() ? null : result.toArray(new String[result.size()]);

    }

    public static void main(String[] args) {
        String s = ",asd,asd,dsa,dsa,we,we,xmtt,ttmx ,ttmx,";
        String[] s1 = splitKeyWord(s);
        for (String aS1 : s1) {
            System.out.println(aS1);
        }
    }

}