package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.MyCustomerDao;
import com.ekexiu.console.system.po.MyCustomer;
import com.ekexiu.console.system.vo.ConsoleAuthUser;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;


@Path("/sys/mycustomer")
public class MyCustomerService {
	@Autowrie
	private MyCustomerDao myCustomerDao;

	public MyCustomerDao getMyCustomerDao() {
		return myCustomerDao;
	}

	public void setMyCustomerDao(MyCustomerDao myCustomerDao) {
		this.myCustomerDao = myCustomerDao;
	}
	@Get
	@Path("/pq")
	public PageQueryResult<MyCustomer> pageQuery(@JdbcConn Connection con, @Nullable @Like String name, @Nullable @Like String address, @Nullable @Like String orgname, @Nullable String powType, @LoginUser ConsoleAuthUser user, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException{
		String Cname = null;
		if(name!=null)
		{
			Cname="%"+name+"%";
		}
		String Caddress = null;
		if(address!=null)
		{
			Caddress="%"+address+"%";
		}
		String Corgname = null;
		if(orgname!=null)
		{
			Corgname="%"+orgname+"%";
		}
		return this.myCustomerDao.query(con, Cname, Caddress, Corgname, powType,user.getId(), pageSize, pageNo);
	}
	@Get
	@Path("/allpq")
	public PageQueryResult<MyCustomer> pageQuery(@JdbcConn Connection con, @Nullable @Like String name, @Nullable @Like String address, @Nullable @Like String orgname, @Nullable String powType, @Nullable @Like String cuserName, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException{
		String Cname=null;
		if(name!=null)
		{
			Cname="%"+name+"%";
		}
		String Caddress=null;
		if(address!=null)
		{
			Caddress="%"+address+"%";
		}
		String Corgname =null;
		if(orgname!=null)
		{
			Corgname="%"+orgname+"%";
		}
		String Cusernames=null;
		if(cuserName!=null)
		{
			Cusernames="%"+cuserName+"%";
		}
		return this.myCustomerDao.allquery(con, Cname, Caddress,Corgname,powType,Cusernames, pageSize, pageNo);
	}
	@Get
	@Path("/id/{id}")
	public MyCustomer query(@JdbcConn Connection con, @PathVar String id)throws SQLException{
		return this.myCustomerDao.query(con, id);
	}	
}
