package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.ResourceDao;
import com.ekexiu.console.system.po.Resource;
import com.ekexiu.console.system.pojo.ResourceInfo;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

/**
 * Created by TT on 2017/8/9.
 */
@Path("/resource")
public class ResourceService {
    @Autowrie
    private ResourceDao resourceDao;
    @Autowrie
    private KeyWordService keyWordService;

    public ResourceDao getResourceDao() {
        return resourceDao;
    }

    public void setResourceDao(ResourceDao resourceDao) {
        this.resourceDao = resourceDao;
    }

    public KeyWordService getKeyWordService() {
        return keyWordService;
    }

    public void setKeyWordService(KeyWordService keyWordService) {
        this.keyWordService = keyWordService;
    }

    @Path("/pq")
    @Get
    public PageQueryResult<ResourceInfo> pageQueryResult(@JdbcConn Connection con, @Nullable String resourceName, @Nullable String name, int orderBy, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException {
        if (orderBy == 1) {
            return this.resourceDao.queryByTime(con, resourceName == null ? null : "%" + resourceName + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        if (orderBy == 2) {
            return this.resourceDao.queryByPV(con, resourceName == null ? null : "%" + resourceName + "%",  name == null ? "%" : "%" + name + "%", bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
        }
        return null;
    }

    @Post
    @Path("/deleteResource")
    public void deleteResource(@JdbcConn(true) Connection con, String resourceId) throws SQLException {
        //修改文章状态为删除
        this.resourceDao.updateStatus(con, resourceId, "3");
    }

    @Post
    @Path("/sortNum")
    public void updateSortNum(@JdbcConn(true) Connection con,String resourceId,long sortNum) throws SQLException{
        this.resourceDao.updateSortNum(con, resourceId, sortNum);
    }

    @Get
    @Path("/id/{id}")
    public Resource query(@JdbcConn Connection con, @PathVar String id) throws SQLException {
        return this.resourceDao.query(con, id);
    }

    @Post
    @Path("/subject")
    public void updateSubject(@JdbcConn(true) Connection con,String resourceId,@Nullable String subject) throws SQLException {
        this.resourceDao.updateSubject(con, resourceId, subject);
        this.keyWordService.refreshResource(con, resourceId, subject);
    }
}
