package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.*;
import com.ekexiu.console.system.po.*;
import com.ekexiu.console.system.vo.ConsoleAuthUser;
import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.web.annotation.LoginUser;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Delete;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.operate.Post;
import org.jfw.apt.web.annotation.operate.Put;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.apt.web.annotation.param.RequestBody;
import org.jfw.util.DateUtil;
import org.jfw.util.PageQueryResult;
import org.jfw.util.StringUtil;

import java.io.IOException;
import java.sql.Connection;
import java.sql.SQLException;
import java.util.*;

/**
 * Created by TT on 2017/7/7.
 */
@Path("/userinfo")
public class UserInfoService {
    public static final String DEFAULT_PASS_WORD = "11111111111111111111111111111111";
    @Autowrie
    private UserInfoDao userInfoDao;
    @Autowrie
    private LuserDao luserDao;
    @Autowrie
    private ResearchAreaDao researchAreaDao;
    @Autowrie
    private ProjectDao projectDao;
    @Autowrie
    private HonorDao honorDao;
    @Autowrie
    private PartTimeJobDao partTimeJobDao;
    @Autowrie
    private ProfessorEduBgDao professorEduBgDao;
    @Autowrie
    private ProfessorService professorService;
    @Autowrie
    private KeyWordService keyWordService;

    public PartTimeJobDao getPartTimeJobDao() {
        return partTimeJobDao;
    }

    public void setPartTimeJobDao(PartTimeJobDao partTimeJobDao) {
        this.partTimeJobDao = partTimeJobDao;
    }

    public ProfessorEduBgDao getProfessorEduBgDao() {
        return professorEduBgDao;
    }

    public void setProfessorEduBgDao(ProfessorEduBgDao professorEduBgDao) {
        this.professorEduBgDao = professorEduBgDao;
    }

    public HonorDao getHonorDao() {
        return honorDao;
    }

    public void setHonorDao(HonorDao honorDao) {
        this.honorDao = honorDao;
    }

    public ProjectDao getProjectDao() {
        return projectDao;
    }

    public void setProjectDao(ProjectDao projectDao) {
        this.projectDao = projectDao;
    }

    public ResearchAreaDao getResearchAreaDao() {
        return researchAreaDao;
    }

    public void setResearchAreaDao(ResearchAreaDao researchAreaDao) {
        this.researchAreaDao = researchAreaDao;
    }

    public static String getDefaultPassWord() {
        return DEFAULT_PASS_WORD;
    }

    public ProfessorService getProfessorService() {
        return professorService;
    }

    public void setProfessorService(ProfessorService professorService) {
        this.professorService = professorService;
    }

    public LuserDao getLuserDao() {
        return luserDao;
    }

    public void setLuserDao(LuserDao luserDao) {
        this.luserDao = luserDao;
    }

    public UserInfoDao getUserInfoDao() {
        return userInfoDao;
    }

    public void setUserInfoDao(UserInfoDao userInfoDao) {
        this.userInfoDao = userInfoDao;
    }

    public KeyWordService getKeyWordService() {
        return keyWordService;
    }

    public void setKeyWordService(KeyWordService keyWordService) {
        this.keyWordService = keyWordService;
    }

    @Path("/insert")
    @Put
    public void insert(@JdbcConn(true) Connection con, @RequestBody UserInfo userInfo, @LoginUser ConsoleAuthUser user) throws SQLException {
        String id = StringUtil.buildUUID();
        userInfo.setId(id);
        userInfo.setState("1");
        userInfo.setCreator(user.getId());
        userInfo.setCreatorName(user.getName());
        userInfo.setCreateTime(DateUtil.formatDateTime(System.currentTimeMillis()));
        this.userInfoDao.insert(con, userInfo);
    }

    @Path("/update")
    @Put
    public void update(@JdbcConn(true) Connection con, @RequestBody UserInfo userInfo) throws SQLException {
        this.userInfoDao.update(con, userInfo);
    }

    @Path("/updateState")
    @Post
    public void updateState(@JdbcConn(true) Connection con, String id) throws SQLException {
        UserInfo userInfo = this.userInfoDao.query(con, id);
        userInfo.setState("2");
        this.userInfoDao.update(con, userInfo);
    }

    @Delete
    @Path("/del/{id}")
    public int delete(@JdbcConn(true) Connection con, @PathVar String id) throws SQLException {
        UserInfo userInfo = this.userInfoDao.query(con, id);
        if (userInfo!=null) {
            if(Objects.equals(userInfo.getState(), "1") || Objects.equals(userInfo.getState(), "4")) {
                this.userInfoDao.delete(con, id);
                return 1;//删除成功
            }else {
                return 2;//无法删除
            }
        }else
            return 3;//没有账户
    }

    @Path("/id/{id}")
    @Get
    public UserInfo queryOne(@JdbcConn Connection con, @PathVar String id) throws SQLException {
        return this.userInfoDao.query(con, id);
    }

    @Path("/pq")
    @Get
    public PageQueryResult<UserInfo> pageQueryPerson(@JdbcConn Connection con, @LoginUser ConsoleAuthUser user, @Nullable String name, @Nullable String orgName, @Nullable String state, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize) throws SQLException {
        return this.userInfoDao.queryPerson(con, user.getId(), name == null ? null : "%" + name + "%", orgName == null ? null : "%" + orgName + "%", state, bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
    }

    @Path("/pqAll")
    @Get
    PageQueryResult<UserInfo> pageQueryAll(@JdbcConn Connection con, @Nullable String creatorName, @Nullable String name, @Nullable String orgName, @Nullable String state, @Nullable String bt, @Nullable String et, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize) throws SQLException {
        return this.userInfoDao.queryAll(con, creatorName == null ? null : "%" + creatorName + "%",name == null ? null : "%" + name + "%", orgName == null ? null : "%" + orgName + "%", state, bt == null ? null : bt + "000000", et == null ? null : et + "235959", pageSize, pageNo);
    }

    @Path("/entryCheck")
    @Get
    public Boolean entryCheck(@JdbcConn Connection con, @Nullable String mobile, @Nullable String email) throws SQLException {
        UserInfo userInfo1 = this.userInfoDao.entryCheck(con, mobile);
        UserInfo userInfo2 = this.userInfoDao.entryCheck(con, email);
        Luser luser1 = this.luserDao.check(con, mobile);
        Luser luser2 = this.luserDao.check(con, email);
        return userInfo1 == null && userInfo2 == null && luser1 == null && luser2 == null;
    }

    @Path("/editCheck")
    @Get
    public Boolean editCheck(@JdbcConn Connection con, @Nullable String mobile, @Nullable String email,String id) throws SQLException {
        String userInfoId = this.userInfoDao.queryByKey(con, mobile);
        if ((userInfoId != null) && (!Objects.equals(userInfoId, id))){
            return false;
        }
        String userInfoId1 = this.userInfoDao.queryByKey(con, email);
        if ((userInfoId1 != null) && (!Objects.equals(userInfoId1, id))){
            return false;
        }
        Luser luser1 = this.luserDao.check(con, mobile);
        Luser luser2 = this.luserDao.check(con, email);
        return luser1 == null && luser2 == null;
    }

    @Path("/reviewCheck")
    @Get
    public Boolean reviewCheck(@JdbcConn Connection con, @Nullable String mobile, @Nullable String email) throws SQLException {
        Luser luser1 = this.luserDao.check(con, mobile);
        Luser luser2 = this.luserDao.check(con, email);
        return luser1 == null && luser2 == null;
    }

    @Path("/import")
    @Post
    public int importData(@JdbcConn(true) Connection con, String id, String reviewer, String reviewTime, String reviewerName,
                           Integer authentication, Integer authStatus, Integer authStatusExpert, @Nullable Integer sortFirst) throws SQLException, IOException {
        UserInfo userInfo = this.userInfoDao.query(con, id);
        if (userInfo!=null) {
            if (Objects.equals(userInfo.getState(), "2")) {
                userInfo.setState("3");
                userInfo.put("reviewer", reviewer);
                userInfo.put("reviewTime", reviewTime);
                userInfo.put("reviewerName", reviewerName);
                userInfo.put("authentication", authentication);
                userInfo.put("authStatus", authStatus);
                userInfo.put("authStatusExpert", authStatusExpert);
                userInfo.put("sortFirst", sortFirst);
                this.userInfoDao.update(con, userInfo);

                Luser luser = new Luser();
                luser.setId(userInfo.getId());
                luser.setEmail(userInfo.getEmail());
                Random rd = new Random();
                int code = rd.nextInt(1000000);
                String inviteCode = String.format("%06d", code);
                luser.setInviteCode(inviteCode);
                luser.setMobilePhone(userInfo.getMobile());
                luser.setPasswd(DEFAULT_PASS_WORD);
                luser.setUserType("0");
                luser.setCreateTime(userInfo.getCreateTime());
                this.luserDao.insert(con, luser);

                Professor professor = new Professor();
                String subject = (String) userInfo.get("subject");
                String industry = (String) userInfo.get("industry");
                professor.setId(userInfo.getId());
                professor.setName(userInfo.getName());
                professor.setEmail((String) userInfo.get("pEmail"));
                professor.setPhone((String) userInfo.get("pMobile"));
                professor.setTitle((String) userInfo.get("title"));
                professor.setOffice((String) userInfo.get("office"));
                professor.setSubject((String) userInfo.get("subject"));
                professor.setDepartment((String) userInfo.get("department"));
                professor.setIndustry((String) userInfo.get("industry"));
                professor.setDescp((String) userInfo.get("descp"));
                professor.setCreateTime(userInfo.getCreateTime());
                professor.setModifyTime(userInfo.getCreateTime());
                professor.setAddress((String) userInfo.get("address"));
                professor.setProvince((String) userInfo.get("province"));
                professor.setAuthentication((Integer) userInfo.get("authentication"));
                if (authStatusExpert == 3){
                    professor.setAuthType(1);
                }else {
                    professor.setAuthType(0);
                }
                if(userInfo.get("authStatus")!=null) {
                    professor.setAuthStatus((Integer) userInfo.get("authStatus"));
                }else {
                    professor.setAuthStatus(0);
                }
                if (userInfo.get("authStatusExpert")!=null) {
                    professor.setAuthStatusExpert((Integer) userInfo.get("authStatusExpert"));
                }else {
                    professor.setAuthStatusExpert(0);
                }
                if (userInfo.get("sortFirst")!=null) {
                    professor.setSortFirst((Integer) userInfo.get("sortFirst"));
                }else {
                    professor.setSortFirst(0);
                }
                professor.setProfessorState(0);
                this.professorService.insert(con, professor, userInfo.getOrgName());
                this.keyWordService.refreshProfessor(con, id,subject + "," + industry);

                ArrayList<String> areas = (ArrayList<String>) userInfo.get("researchArea");
                if (areas != null) {
                    ResearchArea researchArea = new ResearchArea();
                    int sortNum = 1;
                    for (String area : areas) {
                        researchArea.setProfessorId(userInfo.getId());
                        researchArea.setCaption(area);
                        researchArea.setSortNum(sortNum++);
                        this.researchAreaDao.insert(con, researchArea);
                    }
                }

                ArrayList<Map<String, Object>> projects = (ArrayList<Map<String, Object>>) userInfo.get("projects");
                if (projects != null) {
                    for (Map<String, Object> project : projects) {
                        Project project1 = new Project();
                        String projectId = StringUtil.buildUUID();
                        project1.setId(projectId);
                        project1.setName((String) project.get("projectName"));
                        project1.setProfessorId(userInfo.getId());
                        project1.setDescp((String) project.get("projectDescp"));
                        project1.setStartMonth((String) project.get("projectStart"));
                        if ("至今".equals(project.get("projectStop"))) {
                            project1.setStopMonth(null);
                        }else {
                            project1.setStopMonth((String) project.get("projectStop"));
                        }
                        this.projectDao.insert(con, project1);
                    }
                }

                ArrayList<Map<String, Object>> honors = (ArrayList<Map<String, Object>>) userInfo.get("honors");
                if (honors != null) {
                    for (Map<String, Object> honor : honors) {
                        Honor honor1 = new Honor();
                        String honorId = StringUtil.buildUUID();
                        honor1.setId(honorId);
                        honor1.setProfessorId(userInfo.getId());
                        honor1.setName((String) honor.get("honorName"));
                        honor1.setDescp((String) honor.get("honorDescp"));
                        honor1.setYear((String) honor.get("honorYear"));
                        this.honorDao.insert(con, honor1);
                    }
                }

                ArrayList<Map<String, Object>> jobs = (ArrayList<Map<String, Object>>) userInfo.get("jobs");
                if (jobs != null) {
                    for (Map<String, Object> job : jobs) {
                        PartTimeJob partTimeJob = new PartTimeJob();
                        String jobId = StringUtil.buildUUID();
                        partTimeJob.setId(jobId);
                        partTimeJob.setProfessorId(userInfo.getId());
                        partTimeJob.setCompany((String) job.get("jobCompany"));
                        partTimeJob.setDepartment((String) job.get("jobDepartment"));
                        partTimeJob.setTitle((String) job.get("jobTitle"));
                        partTimeJob.setStartMonth((String) job.get("jobStart"));
                        if ("至今".equals(job.get("jobStop"))) {
                            partTimeJob.setStopMonth(null);
                        }else {
                            partTimeJob.setStopMonth((String) job.get("jobStop"));
                        }
                        this.partTimeJobDao.insert(con, partTimeJob);
                    }
                }

                List<Map<String, Object>> edus = (List<Map<String, Object>>) userInfo.get("edus");
                if (edus != null) {
                    for (Map<String, Object> edu : edus) {
                        ProfessorEduBg professorEduBg = new ProfessorEduBg();
                        String eduId = StringUtil.buildUUID();
                        professorEduBg.setId(eduId);
                        professorEduBg.setProfessorId(userInfo.getId());
                        professorEduBg.setSchool((String) edu.get("eduSchool"));
                        professorEduBg.setCollege((String) edu.get("eduCollege"));
                        professorEduBg.setMajor((String) edu.get("eduMajor"));
                        professorEduBg.setDegree((String) edu.get("eduDegree"));
                        professorEduBg.setYear((String) edu.get("eduYear"));
                        this.professorEduBgDao.insert(con, professorEduBg);
                    }
                }
                return 1;//导入成功
            }else
                return 2;//状态不符合要求
        }else
            return 3;//用户不存在
    }
}