package com.ekexiu.console.system.service;

import com.ekexiu.console.system.dao.ViewAllcustomerDao;
import com.ekexiu.console.system.po.ViewAllcustomer;

import org.jfw.apt.annotation.Autowrie;
import org.jfw.apt.annotation.DefaultValue;
import org.jfw.apt.annotation.Nullable;
import org.jfw.apt.orm.annotation.dao.param.Like;
import org.jfw.apt.web.annotation.Path;
import org.jfw.apt.web.annotation.operate.Get;
import org.jfw.apt.web.annotation.param.JdbcConn;
import org.jfw.apt.web.annotation.param.PathVar;
import org.jfw.util.PageQueryResult;

import java.sql.Connection;
import java.sql.SQLException;

@Path("/sys/viewallcustomer")
public class ViewAllcustomerService {
	@Autowrie
	private ViewAllcustomerDao viewAllcustomerDao;

	public ViewAllcustomerDao getViewAllcustomerDao() {
		return viewAllcustomerDao;
	}

	public void setViewAllcustomerDao(ViewAllcustomerDao viewAllcustomerDao) {
		this.viewAllcustomerDao = viewAllcustomerDao;
	}
	@Get
	@Path("/pq")
	public PageQueryResult<ViewAllcustomer> pageQuery(@JdbcConn Connection con, @Nullable @Like String name, @Nullable @Like String address, @Nullable @Like String orgname, @Nullable Integer sendMailStatus, @DefaultValue("1") int pageNo, @DefaultValue("10") int pageSize)throws SQLException{
		String Cname = null;
		if(name!=null)
		{
			Cname="%"+name+"%";
		}
		String Caddress = null;
		if(address!=null)
		{
			Caddress="%"+address+"%";
		}
		String Corgname = null;
		if(orgname!=null)
		{
			Corgname="%"+orgname+"%";
		}
		return this.viewAllcustomerDao.query(con, Cname, Caddress, Corgname, sendMailStatus, pageSize, pageNo);
	}

	@Get
	@Path("/id/{id}")
	public ViewAllcustomer query(@JdbcConn Connection con, @PathVar String id)throws SQLException{
		return this.viewAllcustomerDao.query(con, id);
	}	
}
