package com.ekexiu.console.util;

import com.ekexiu.console.system.service.*;
import org.jfw.util.bean.AfterBeanFactory;
import org.jfw.util.bean.BeanFactory;
import org.jfw.util.context.JfwAppContext;

import javax.sql.DataSource;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;
import java.util.concurrent.ScheduledExecutorService;

public class GlobalInitBean implements AfterBeanFactory {
	private DataSource dataSource;
	private ScheduledExecutorService service;
	private BeanFactory beanf;
	
	
	public BeanFactory getBeanf() {
		return beanf;
	}


	public void setBeanf(BeanFactory beanf) {
		this.beanf = beanf;
	}


	public DataSource getDataSource() {
		return dataSource;
	}


	public void setDataSource(DataSource dataSource) {
		this.dataSource = dataSource;
	}


	public ScheduledExecutorService getService() {
		return service;
	}


	public void setService(ScheduledExecutorService service) {
		this.service = service;
	}


	@Override
	public void handle(BeanFactory bf) throws Throwable {
		this.beanf = bf;
		this.service = JfwAppContext.getScheduledExecutorService();
		this.dataSource = (DataSource) bf.getBean("dataSource");
		for(ListIterator<Initable> it= this.loadInitables().listIterator() ; it.hasNext();){
			it.next().init(this);
		}
	}
	
	public List<Initable> loadInitables()throws Exception{
		LinkedList<Initable> list = new LinkedList<Initable>();
		list.add(new Initable() {			
			@Override
			public void init(GlobalInitBean gib) throws Exception {
				getBean(DictService.class).initByDataSource(dataSource);
			}
		});
		list.add(new Initable() {			
			@Override
			public void init(GlobalInitBean gib) throws Exception {
				getBean(RightService.class).initByDataSource(dataSource);
			}
		});
		list.add(new Initable() {			
			@Override
			public void init(GlobalInitBean gib) throws Exception {
				getBean(RoleService.class).initByDataSource(dataSource);
			}
		});
		list.add(new Initable() {			
			@Override
			public void init(GlobalInitBean gib) throws Exception {
				getBean(SysResourceService.class).initByDataSource(dataSource);
			}
		});
		return list;
	}
	public <T> T getBean(Class<T> cls){
		return this.beanf.getBean(classNameToBeanName(cls), cls);
	}

	public static String classNameToBeanName(Class<?> cls){
		return cls.getName().replaceAll("\\.","_");
	}
	
	public static void main(String[] args){
		System.out.println(classNameToBeanName(GlobalInitBean.class));
	}
}
